SFML - Simple and Fast Multimedia Library

SFML 2.6.1

- Main Page
- Related Pages
- Topics
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
sf::Sprite Class Reference
Graphics module

Drawable representation of a texture, with its own transformations, color, etc. More...

`#include <SFML/Graphics/Sprite.hpp>`

Inheritance diagram for sf::Sprite:

## Public Member Functions
| Sprite ()
| Default constructor.
| Sprite (const Texture &texture)
| Construct the sprite from a source texture.
| Sprite (const Texture &texture, const IntRect &rectangle)
| Construct the sprite from a sub-rectangle of a source texture.
void | setTexture (const Texture &texture, bool resetRect=false)
| Change the source texture of the sprite.
void | setTextureRect (const IntRect &rectangle)
| Set the sub-rectangle of the texture that the sprite will display.
void | setColor (const Color &color)
| Set the global color of the sprite.
const Texture * | getTexture () const
| Get the source texture of the sprite.
const IntRect & | getTextureRect () const
| Get the sub-rectangle of the texture displayed by the sprite.
const Color & | getColor () const
| Get the global color of the sprite.
FloatRect | getLocalBounds () const
| Get the local bounding rectangle of the entity.
FloatRect | getGlobalBounds () const
| Get the global bounding rectangle of the entity.
void | setPosition (float x, float y)
| set the position of the object
void | setPosition (const Vector2f &position)
| set the position of the object
void | setRotation (float angle)
| set the orientation of the object
void | setScale (float factorX, float factorY)
| set the scale factors of the object
void | setScale (const Vector2f &factors)
| set the scale factors of the object
void | setOrigin (float x, float y)
| set the local origin of the object
void | setOrigin (const Vector2f &origin)
| set the local origin of the object
const Vector2f & | getPosition () const
| get the position of the object
float | getRotation () const
| get the orientation of the object
const Vector2f & | getScale () const
| get the current scale of the object
const Vector2f & | getOrigin () const
| get the local origin of the object
void | move (float offsetX, float offsetY)
| Move the object by a given offset.
void | move (const Vector2f &offset)
| Move the object by a given offset.
void | rotate (float angle)
| Rotate the object.
void | scale (float factorX, float factorY)
| Scale the object.
void | scale (const Vector2f &factor)
| Scale the object.
const Transform & | getTransform () const
| get the combined transform of the object
const Transform & | getInverseTransform () const
| get the inverse of the combined transform of the object

## Detailed Description

Drawable representation of a texture, with its own transformations, color, etc.

sf::Sprite is a drawable class that allows to easily display a texture (or a part of it) on a render target.

It inherits all the functions from sf::Transformable: position, rotation, scale, origin. It also adds sprite-specific properties such as the texture to use, the part of it to display, and some convenience functions to change the overall color of the sprite, or to get its bounding rectangle.

sf::Sprite works in combination with the sf::Texture class, which loads and provides the pixel data of a given texture.

The separation of sf::Sprite and sf::Texture allows more flexibility and better performances: indeed a sf::Texture is a heavy resource, and any operation on it is slow (often too slow for real-time applications). On the other side, a sf::Sprite is a lightweight object which can use the pixel data of a sf::Texture and draw it with its own transformation/color/blending attributes.

It is important to note that the sf::Sprite instance doesn't copy the texture that it uses, it only keeps a reference to it. Thus, a sf::Texture must not be destroyed while it is used by a sf::Sprite (i.e. never write a function that uses a local sf::Texture instance for creating a sprite).

See also the note on coordinates and undistorted rendering in sf::Transformable.

Usage example:

// Declare and load a texture
sf::Texture texture;
texture.loadFromFile("texture.png");
// Create a sprite
sf::Sprite sprite;
sprite.setTexture(texture);
sprite.setTextureRect(sf::IntRect(10, 10, 50, 30));
sprite.setColor(sf::Color(255, 255, 255, 200));
sprite.setPosition(100, 25);
// Draw it
window.draw(sprite);
sf::Color
Utility class for manipulating RGBA colors.
Definition Color.hpp:41
sf::Rect< int >
sf::Sprite
Drawable representation of a texture, with its own transformations, color, etc.
Definition Sprite.hpp:48
sf::Sprite::setColor
void setColor(const Color &color)
Set the global color of the sprite.
sf::Sprite::setTexture
void setTexture(const Texture &texture, bool resetRect=false)
Change the source texture of the sprite.
sf::Sprite::setTextureRect
void setTextureRect(const IntRect &rectangle)
Set the sub-rectangle of the texture that the sprite will display.
sf::Texture
Image living on the graphics card that can be used for drawing.
Definition Texture.hpp:49
sf::Texture::loadFromFile
bool loadFromFile(const std::string &filename, const IntRect &area=IntRect())
Load the texture from a file on disk.
sf::Transformable::setPosition
void setPosition(float x, float y)
set the position of the object

See also
  sf::Texture, sf::Transformable

Definition at line 47 of file Sprite.hpp.

## Constructor & Destructor Documentation

## ◆ Sprite() [1/3]

sf::Sprite::Sprite | ( |  | ) |

Default constructor.

Creates an empty sprite with no source texture.

## ◆ Sprite() [2/3]

sf::Sprite::Sprite | ( | const Texture & | texture | ) |
| explicit

Construct the sprite from a source texture.

Parameters

  texture | Source texture

See also
  setTexture

## ◆ Sprite() [3/3]

sf::Sprite::Sprite | ( | const Texture & | texture,
|  | const IntRect & | rectangle
| ) |  |

Construct the sprite from a sub-rectangle of a source texture.

Parameters

  texture | Source texture
  rectangle | Sub-rectangle of the texture to assign to the sprite

See also
  setTexture, setTextureRect

## Member Function Documentation

## ◆ getColor()

const Color & sf::Sprite::getColor | ( |  | ) | const

Get the global color of the sprite.

Returns
  Global color of the sprite

See also
  setColor

## ◆ getGlobalBounds()

FloatRect sf::Sprite::getGlobalBounds | ( |  | ) | const

Get the global bounding rectangle of the entity.

The returned rectangle is in global coordinates, which means that it takes into account the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the sprite in the global 2D world's coordinate system.

Returns
  Global bounding rectangle of the entity

## ◆ getInverseTransform()

const Transform & sf::Transformable::getInverseTransform | ( |  | ) | const
| inherited

get the inverse of the combined transform of the object

Returns
  Inverse of the combined transformations applied to the object

See also
  getTransform

## ◆ getLocalBounds()

FloatRect sf::Sprite::getLocalBounds | ( |  | ) | const

Get the local bounding rectangle of the entity.

The returned rectangle is in local coordinates, which means that it ignores the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the entity in the entity's coordinate system.

Returns
  Local bounding rectangle of the entity

## ◆ getOrigin()

const Vector2f & sf::Transformable::getOrigin | ( |  | ) | const
| inherited

get the local origin of the object

Returns
  Current origin

See also
  setOrigin

## ◆ getPosition()

const Vector2f & sf::Transformable::getPosition | ( |  | ) | const
| inherited

get the position of the object

Returns
  Current position

See also
  setPosition

## ◆ getRotation()

float sf::Transformable::getRotation | ( |  | ) | const
| inherited

get the orientation of the object

The rotation is always in the range [0, 360].

Returns
  Current rotation, in degrees

See also
  setRotation

## ◆ getScale()

const Vector2f & sf::Transformable::getScale | ( |  | ) | const
| inherited

get the current scale of the object

Returns
  Current scale factors

See also
  setScale

## ◆ getTexture()

const Texture * sf::Sprite::getTexture | ( |  | ) | const

Get the source texture of the sprite.

If the sprite has no source texture, a NULL pointer is returned. The returned pointer is const, which means that you can't modify the texture when you retrieve it with this function.

Returns
  Pointer to the sprite's texture

See also
  setTexture

## ◆ getTextureRect()

const IntRect & sf::Sprite::getTextureRect | ( |  | ) | const

Get the sub-rectangle of the texture displayed by the sprite.

Returns
  Texture rectangle of the sprite

See also
  setTextureRect

## ◆ getTransform()

const Transform & sf::Transformable::getTransform | ( |  | ) | const
| inherited

get the combined transform of the object

Returns
  Transform combining the position/rotation/scale/origin of the object

See also
  getInverseTransform

## ◆ move() [1/2]

void sf::Transformable::move | ( | const Vector2f & | offset | ) |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

object.setPosition(object.getPosition() + offset);
sf::Transformable::getPosition
const Vector2f & getPosition() const
get the position of the object

Parameters

  offset | Offset

See also
  setPosition

## ◆ move() [2/2]

void sf::Transformable::move | ( | float | offsetX,
|  | float | offsetY
| ) |  |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f pos = object.getPosition();
object.setPosition(pos.x + offsetX, pos.y + offsetY);
sf::Vector2< float >
sf::Vector2::x
T x
X coordinate of the vector.
Definition Vector2.hpp:75
sf::Vector2::y
T y
Y coordinate of the vector.
Definition Vector2.hpp:76

Parameters

  offsetX | X offset
  offsetY | Y offset

See also
  setPosition

## ◆ rotate()

void sf::Transformable::rotate | ( | float | angle | ) |
| inherited

Rotate the object.

This function adds to the current rotation of the object, unlike setRotation which overwrites it. Thus, it is equivalent to the following code:

object.setRotation(object.getRotation() + angle);
sf::Transformable::getRotation
float getRotation() const
get the orientation of the object

Parameters

  angle | Angle of rotation, in degrees

## ◆ scale() [1/2]

void sf::Transformable::scale | ( | const Vector2f & | factor | ) |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factor.x, scale.y * factor.y);
sf::Transformable::scale
void scale(float factorX, float factorY)
Scale the object.

Parameters

  factor | Scale factors

See also
  setScale

## ◆ scale() [2/2]

void sf::Transformable::scale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factorX, scale.y * factorY);

Parameters

  factorX | Horizontal scale factor
  factorY | Vertical scale factor

See also
  setScale

## ◆ setColor()

void sf::Sprite::setColor | ( | const Color & | color | ) |

Set the global color of the sprite.

This color is modulated (multiplied) with the sprite's texture. It can be used to colorize the sprite, or change its global opacity. By default, the sprite's color is opaque white.

Parameters

  color | New color of the sprite

See also
  getColor

## ◆ setOrigin() [1/2]

void sf::Transformable::setOrigin | ( | const Vector2f & | origin | ) |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  origin | New origin

See also
  getOrigin

## ◆ setOrigin() [2/2]

void sf::Transformable::setOrigin | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new origin
  y | Y coordinate of the new origin

See also
  getOrigin

## ◆ setPosition() [1/2]

void sf::Transformable::setPosition | ( | const Vector2f & | position | ) |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  position | New position

See also
  move, getPosition

## ◆ setPosition() [2/2]

void sf::Transformable::setPosition | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new position
  y | Y coordinate of the new position

See also
  move, getPosition

## ◆ setRotation()

void sf::Transformable::setRotation | ( | float | angle | ) |
| inherited

set the orientation of the object

This function completely overwrites the previous rotation. See the rotate function to add an angle based on the previous rotation instead. The default rotation of a transformable object is 0.

Parameters

  angle | New rotation, in degrees

See also
  rotate, getRotation

## ◆ setScale() [1/2]

void sf::Transformable::setScale | ( | const Vector2f & | factors | ) |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factors | New scale factors

See also
  scale, getScale

## ◆ setScale() [2/2]

void sf::Transformable::setScale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factorX | New horizontal scale factor
  factorY | New vertical scale factor

See also
  scale, getScale

## ◆ setTexture()

void sf::Sprite::setTexture | ( | const Texture & | texture,
|  | bool | resetRect = `false`
| ) |  |

Change the source texture of the sprite.

The texture argument refers to a texture that must exist as long as the sprite uses it. Indeed, the sprite doesn't store its own copy of the texture, but rather keeps a pointer to the one that you passed to this function. If the source texture is destroyed and the sprite tries to use it, the behavior is undefined. If resetRect is true, the TextureRect property of the sprite is automatically adjusted to the size of the new texture. If it is false, the texture rect is left unchanged.

Parameters

  texture | New texture
  resetRect | Should the texture rect be reset to the size of the new texture?

See also
  getTexture, setTextureRect

## ◆ setTextureRect()

void sf::Sprite::setTextureRect | ( | const IntRect & | rectangle | ) |

Set the sub-rectangle of the texture that the sprite will display.

The texture rect is useful when you don't want to display the whole texture, but rather a part of it. By default, the texture rect covers the entire texture.

Parameters

  rectangle | Rectangle defining the region of the texture to display

See also
  getTextureRect, setTexture

The documentation for this class was generated from the following file:

- Sprite.hpp